
int main(void)
{
	unsigned int j;
	unsigned char first_write;
	uart_init();
    timers_init();
    gpiote_init();	  
    buttons_init();
    ble_stack_init();
    bond_manager_init();
    gap_params_init();
    advertising_init(BLE_GAP_ADV_FLAGS_LE_ONLY_LIMITED_DISC_MODE);
    services_init();
    conn_params_init();
    sec_params_init();
	  led_init();	  
    // Start advertising
    advertising_start();		
	//calculating flash address location to check first write
	pg_size = NRF_FICR->CODEPAGESIZE;
	pg_num  = NRF_FICR->CODESIZE - 2;
	addr = (uint32_t *)(pg_size * pg_num);
	FIRST_WRITE = addr;
	//reading first write value
	first_write = *FIRST_WRITE;
	//checking if not written to flash
	if(first_write == 0xFF)
	{
	  simple_uart_putstring("First Write\n");
		//erasing flash page
		if(NRF_SUCCESS == sd_flash_page_erase(pg_num))
		{
			while (NRF_NVMC->READY == NVMC_READY_READY_Busy)
			{
				// Do nothing.
			}

			nrf_delay_ms(500);
			//modifying first write value
			data[0]= 0x01;
			errcode1 = sd_flash_write(FIRST_WRITE, data,1);
			nrf_delay_ms(500);
		}

		//calculating flash address location to flash the default msg
		pg_size = NRF_FICR->CODEPAGESIZE;
		pg_num  = NRF_FICR->CODESIZE - 1;

		addr = (uint32_t *)(pg_size * pg_num);

		//calculating address locations
		TYPE = addr;
		LENGTH = ++addr;
		DATA = ++addr;

		//erasing flash page
		if(NRF_SUCCESS == sd_flash_page_erase(pg_num))
		{
			while (NRF_NVMC->READY == NVMC_READY_READY_Busy)
			{
				// Do nothing.
			}
			nrf_delay_ms(500);

			//flashing msg type
			data[0]= EMU_TYPE;
			errcode1 = sd_flash_write(TYPE,data,1);
			nrf_delay_ms(500);

			//flashing msg length
			data_len=strlen((const char *)data_buffer);
			data[0]= data_len;
			errcode1 = sd_flash_write(LENGTH,data,1);
			nrf_delay_ms(500);

			//flashing msg
			for(j=0;j<data_len;j++)
			{
				data[j]= data_buffer[j];
			}
			errcode1 = sd_flash_write(DATA,data,data_len);
			nrf_delay_ms(500);
		}
	}
	//checking if flash already written to (valid tag flashed)
	else
	{
	  simple_uart_putstring("Second Write\n");
		//Calculating flash address
		pg_size = NRF_FICR->CODEPAGESIZE;
		pg_num  = NRF_FICR->CODESIZE - 1;

		addr = (uint32_t *)(pg_size * pg_num);

		//calculating address locations
		TYPE = addr;
		LENGTH = ++addr;
		DATA = ++addr;
		//reading type, length and msg
		EMU_TYPE = *TYPE;
		data_len = *LENGTH;
		for(j=0;j<data_len;j++)
		{
			data_buffer[j] = *DATA++;
		}
		 data_buffer[j]='\0';
	}
	// Enter main loop
while(1)
	{

	}
}

